# AP4_MetaData::Value Class Reference

`#include <Ap4MetaData.h>`

Inheritance diagram for AP4_MetaData::Value:

List of all members.

## Public Types
enum | Type { TYPE_BINARY, TYPE_STRING_UTF_8, TYPE_STRING_UTF_16, TYPE_STRING_PASCAL, TYPE_GIF, TYPE_JPEG, TYPE_INT_08_BE, TYPE_INT_16_BE, TYPE_INT_32_BE, TYPE_FLOAT_32_BE, TYPE_FLOAT_64_BE }
enum | TypeCategory { TYPE_CATEGORY_STRING, TYPE_CATEGORY_BINARY, TYPE_CATEGORY_INTEGER, TYPE_CATEGORY_FLOAT }
enum | Meaning { MEANING_UNKNOWN, MEANING_ID3_GENRE, MEANING_BOOLEAN, MEANING_FILE_KIND, MEANING_BINARY_ENCODED_CHARS }
## Public Member Functions
virtual | ~Value ()
Type | GetType () const
TypeCategory | GetTypeCategory () const
Meaning | GetMeaning () const
const AP4_String & | GetLanguage () const
virtual AP4_String | ToString () const =0
virtual AP4_Result | ToBytes (AP4_DataBuffer &bytes) const =0
virtual long | ToInteger () const =0
## Protected Member Functions
| Value (Type type, Meaning meaning=MEANING_UNKNOWN, const char *language=NULL)
## Static Protected Member Functions
static TypeCategory | MapTypeToCategory (Type type)
## Protected Attributes
Type | m_Type
Meaning | m_Meaning
AP4_String | m_Language

## Detailed Description

Definition at line 147 of file Ap4MetaData.h.

## Member Enumeration Documentation

enum AP4_MetaData::Value::Type

Enumerator:

  TYPE_BINARY |
  TYPE_STRING_UTF_8 |
  TYPE_STRING_UTF_16 |
  TYPE_STRING_PASCAL |
  TYPE_GIF |
  TYPE_JPEG |
  TYPE_INT_08_BE |
  TYPE_INT_16_BE |
  TYPE_INT_32_BE |
  TYPE_FLOAT_32_BE |
  TYPE_FLOAT_64_BE |

Definition at line 150 of file Ap4MetaData.h.

enum AP4_MetaData::Value::TypeCategory

Enumerator:

  TYPE_CATEGORY_STRING |
  TYPE_CATEGORY_BINARY |
  TYPE_CATEGORY_INTEGER |
  TYPE_CATEGORY_FLOAT |

Definition at line 164 of file Ap4MetaData.h.

enum AP4_MetaData::Value::Meaning

Enumerator:

  MEANING_UNKNOWN |
  MEANING_ID3_GENRE |
  MEANING_BOOLEAN |
  MEANING_FILE_KIND |
  MEANING_BINARY_ENCODED_CHARS |

Definition at line 171 of file Ap4MetaData.h.

## Constructor & Destructor Documentation

virtual AP4_MetaData::Value::~Value | ( |  | ) | `[inline, virtual]`

Definition at line 180 of file Ap4MetaData.h.

AP4_MetaData::Value::Value | ( | Type | type,
|  | Meaning | meaning = `MEANING_UNKNOWN`,
|  | const char * | language = `NULL` |
| ) |  |  | `[inline, protected]`

Definition at line 196 of file Ap4MetaData.h.

## Member Function Documentation

Type AP4_MetaData::Value::GetType | ( |  | ) | const`[inline]`

Definition at line 183 of file Ap4MetaData.h.

References m_Type.

TypeCategory AP4_MetaData::Value::GetTypeCategory | ( |  | ) | const

Meaning AP4_MetaData::Value::GetMeaning | ( |  | ) | const`[inline]`

Definition at line 185 of file Ap4MetaData.h.

References m_Meaning.

const AP4_String& AP4_MetaData::Value::GetLanguage | ( |  | ) | const`[inline]`

Definition at line 186 of file Ap4MetaData.h.

References m_Language.

virtual AP4_String AP4_MetaData::Value::ToString | ( |  | ) | const`[pure virtual]`

Implemented in AP4_StringMetaDataValue, AP4_IntegerMetaDataValue, AP4_BinaryMetaDataValue, and AP4_AtomMetaDataValue.

virtual AP4_Result AP4_MetaData::Value::ToBytes | ( | AP4_DataBuffer & | bytes | ) | const`[pure virtual]`

Implemented in AP4_StringMetaDataValue, AP4_IntegerMetaDataValue, AP4_BinaryMetaDataValue, and AP4_AtomMetaDataValue.

virtual long AP4_MetaData::Value::ToInteger | ( |  | ) | const`[pure virtual]`

Implemented in AP4_StringMetaDataValue, AP4_IntegerMetaDataValue, AP4_BinaryMetaDataValue, and AP4_AtomMetaDataValue.

static TypeCategory AP4_MetaData::Value::MapTypeToCategory | ( | Type | type | ) | `[static, protected]`

## Member Data Documentation

Type AP4_MetaData::Value::m_Type`[protected]`

Definition at line 202 of file Ap4MetaData.h.

Referenced by GetType().

Meaning AP4_MetaData::Value::m_Meaning`[protected]`

Definition at line 203 of file Ap4MetaData.h.

Referenced by GetMeaning().

AP4_String AP4_MetaData::Value::m_Language`[protected]`

Definition at line 204 of file Ap4MetaData.h.

Referenced by GetLanguage().

The documentation for this class was generated from the following file:

- Ap4MetaData.h